#!/c/Perl/bin//perl -w

# $Id: env.pl.in,v 1.2.2.1 2006/10/20 13:21:57 opengl2772 Exp $
# Copyright (C) 2006 Tadamasa Teranishi
#               2006 Namazu Project All rights reserved.
#     This is free software with ABSOLUTELY NO WARRANTY.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either versions 2, or (at your option)
#  any later version.
#
#  This program is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA
#
#  This file must be encoded in EUC-JP encoding
#
#

#
# print environment
#

use strict;
use English;

eval 'require NKF;';
eval 'require Text::Kakasi;';
eval 'require Text::ChaSen;';
eval 'require MeCab;';

require Cwd;
require 'pltests.pl';

my $cwd = Cwd::cwd();
my $LOG = "$cwd/test-log";

sub env($)
{
    my ($type) = @_;

    if (defined $ENV{$type}) {
        $ENV{$type};
    } else {
        'undef';
    }
}

sub maskenv($)
{
    my ($type) = @_;

    my $mask = env($type);
    
    return $mask if ($mask eq 'undef');

    $mask =~ s/[0-9A-Z]/\*/gi;
    $mask;
}

pltests::putline($LOG, "  *** starting $0");
pltests::putline($LOG, sprintf("OS              : %s", $English::OSNAME));
pltests::putline($LOG, sprintf("Perl            : %f", $English::PERL_VERSION));

my $ver;
eval '$ver = $NKF::VERSION;' or $ver = 'not installed';
pltests::putline($LOG, sprintf("NKF module      : $ver"));
eval '$ver = $Text::Kakasi::VERSION;' or $ver = 'not installed';
pltests::putline($LOG, sprintf("Text::Kakasi    : $ver"));
eval '$ver = $Text::ChaSen::VERSION;' or $ver = 'not installed';
pltests::putline($LOG, sprintf("Text::ChaSen    : $ver"));
eval '$ver = $MeCab::VERSION;' or $ver = 'not installed';
pltests::putline($LOG, sprintf("MeCab module    : $ver"));

pltests::putline($LOG, sprintf("LANGUAGE        : %s", env('LANGUAGE')));
pltests::putline($LOG, sprintf("LC_ALL          : %s", env('LC_ALL')));
pltests::putline($LOG, sprintf("LC_MESSAGES     : %s", env('LC_MESSAGES')));
pltests::putline($LOG, sprintf("LC_CTYPE        : %s", env('LC_CTYPE')));
pltests::putline($LOG, sprintf("LANG            : %s", env('LANG')));
pltests::putline($LOG, sprintf("PATH            : %s", maskenv('PATH')));
pltests::putline($LOG, sprintf("HOME            : %s", env('HOME')));
pltests::putline($LOG, sprintf("NAMAZURC        : %s", env('NAMAZURC')));
pltests::putline($LOG, sprintf("MKNMZRC         : %s", env('MKNMZRC')));
pltests::putline($LOG, sprintf("NAMAZULOCALEDIR : %s", env('NAMAZULOCALEDIR')));
pltests::putline($LOG, sprintf("KANWADICTPATH   : %s", env('KANWADICTPATH')));
pltests::putline($LOG, sprintf("ITAIJIDICTPATH  : %s", env('ITAIJIDICTPATH')));
pltests::putline($LOG, sprintf("MECABRC         : %s", env('MECABRC')));
pltests::putline($LOG, sprintf("pkgdatadir      : %s", env('pkgdatadir')));
pltests::putline($LOG, sprintf("HTTP_proxy      : %s", env('HTTP_proxy')));
pltests::putline($LOG, sprintf("HTTP_proxy_user : %s", maskenv('HTTP_proxy_user')));
pltests::putline($LOG, sprintf("HTTP_proxy_pass : %s", maskenv('HTTP_proxy_pass')));

exit 0;
